diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index bb0386cfb..0c833f89f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -12,6 +12,7 @@ import net.minecraft.core.entity.monster.MobCreeper;
 import net.minecraft.core.entity.monster.MobSlime;
 import net.minecraft.core.entity.monster.MobSpider;
 import net.minecraft.core.entity.monster.MobZombiePig;
+import net.minecraft.core.entity.projectile.Projectile;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.enums.*;
 import net.minecraft.core.achievement.Achievements;
@@ -31,9 +32,6 @@ import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.projectile.ProjectileArrowGolden;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
-import net.minecraft.core.enums.ArtType;
-import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemStack;
@@ -708,112 +706,79 @@ public abstract class Player
     }
 
     @Override
-    public boolean sendDeathMessage(Entity entityKilledBy) {
+    public boolean sendsDeathMessage(Entity entityKilledBy) {
         return true;
     }
-
+    
     @Override
-    public String getDeathMessage(Entity entityKilledBy) {
-        if (this.random.nextInt(8000) == 666) {
-            return getDisplayName() + deathMsgColor + " was killed by Herobrine.";
-        }
-        if (entityKilledBy instanceof MobZombie) {
-            if (entityKilledBy instanceof MobZombiePig) {
-                return getDisplayName() + deathMsgColor + " discovered mob mentality.";
-            } else {
-                return getDisplayName() + deathMsgColor + " became a zombie.";
-            }
-        }
-        if (entityKilledBy instanceof MobCreeper) {
-            return deathMsgColor + "Aw man, " + getDisplayName() + deathMsgColor + " didn't see the creeper.";
-        }
-        if (entityKilledBy instanceof MobSkeleton) {
-            return getDisplayName() + deathMsgColor + " was a victim of aimbot.";
+    public @NotNull String getDeathMessageKey(@Nullable Entity entityKilledBy) {
+        if (this.random.nextInt(8000) == 666) return "messages.death.player.herobrine";
+
+        if (entityKilledBy == null) {
+            if (this.isInLava()) return "messages.death.player.lava";
+    
+            final var tilePos = new TilePos(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z));
+            if (this.world.getBlockType(tilePos) == Blocks.SPIKES) return "messages.death.player.spikes";
+    
+            if (this.fallDistance > 0) return "messages.death.player.fall";
+            if (this.airSupply <= 0) return "messages.death.player.drowned";
+            if (this.remainingFireTicks > 0) return "messages.death.player.fire";
         }
-        if (entityKilledBy instanceof MobSpider) {
-            return getDisplayName() + deathMsgColor + " spent too much time on the web.";
-        }
-        if (entityKilledBy instanceof MobGhast) {
-            return getDisplayName() + deathMsgColor + " didn't return the serve.";
-        }
-        if (entityKilledBy instanceof MobSlime) {
-            return getDisplayName() + deathMsgColor + " was slimed.";
-        }
-        if (entityKilledBy instanceof MobWolf) {
-            return getDisplayName() + deathMsgColor + " got what they deserved.";
-        }
-        if (entityKilledBy instanceof ProjectileArrowGolden) {
-            if (((ProjectileArrowGolden) entityKilledBy).owner instanceof Player) {
-                if (((Player) ((ProjectileArrowGolden) entityKilledBy).owner).uuid.equals(this.uuid)) {
-                    return getDisplayName() + deathMsgColor + " got gold in their eye.";
-                }
-                return getDisplayName() + deathMsgColor + " got pierced by " +
-                    ((ProjectileArrow) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
-            } else {
-                return getDisplayName() + deathMsgColor + " is Swiss cheese.";
-            }
-        }
-        if (entityKilledBy instanceof ProjectileArrow) {
-            if (((ProjectileArrow) entityKilledBy).owner instanceof MobSkeleton) {
-                return getDisplayName() + deathMsgColor + " was a victim of aimbot.";
-            } else if (((ProjectileArrow) entityKilledBy).owner instanceof Player) {
-                if (((Player) ((ProjectileArrow) entityKilledBy).owner).uuid.equals(this.uuid)) {
-                    return getDisplayName() + deathMsgColor + " lost a game of Russian roulette.";
-                }
-                return getDisplayName() + deathMsgColor + " got 360 noscoped by " +
-                    ((ProjectileArrow) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
-            } else {
-                return getDisplayName() + deathMsgColor + " is a pincushion.";
-            }
-        }
-        if (entityKilledBy instanceof ProjectileCannonball) {
-            if (((ProjectileCannonball) entityKilledBy).owner instanceof Player) {
-                if (((Player) ((ProjectileCannonball) entityKilledBy).owner).uuid.equals(this.uuid)) {
-                    return getDisplayName() + deathMsgColor + " jumped too high.";
-                }
-                return getDisplayName() + deathMsgColor + " was fragmented by " +
-                    ((ProjectileCannonball) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
+        
+        else murder: {
+            if (entityKilledBy instanceof EntityPrimedTNT) return "messages.death.player.tnt";
+            if (entityKilledBy instanceof EntityLightning) return "messages.death.player.lightning";
+            if (entityKilledBy instanceof MobZombie) return (entityKilledBy instanceof MobZombiePig)
+                ? "messages.death.player.killed_by.zombie_pig"
+                : "messages.death.player.killed_by.zombie";
+            if (entityKilledBy instanceof MobCreeper) return "messages.death.player.killed_by.creeper";
+            if (entityKilledBy instanceof MobSkeleton) return "messages.death.player.killed_by.skeleton";
+            if (entityKilledBy instanceof MobSpider) return "messages.death.player.killed_by.spider";
+            if (entityKilledBy instanceof MobGhast) return "messages.death.player.killed_by.ghast";
+            if (entityKilledBy instanceof MobSlime) return "messages.death.player.killed_by.slime";
+            if (entityKilledBy instanceof MobWolf) return "messages.death.player.killed_by.wolf";
+            if (entityKilledBy instanceof MobGiant) return "messages.death.player.killed_by.giant";
+            if (entityKilledBy instanceof MobPig) return "messages.death.player.killed_by.pig";
+            
+            if (!(entityKilledBy instanceof Projectile projectile)) break murder;
+
+            // TODO correct key for other sources
+            if (projectile instanceof ProjectileFireball) return "messages.death.player.killed_by.ghast";
+
+            final var archer = projectile.owner;
+            final boolean isPlayer, isSuicide; 
+            if (!(archer instanceof Player player)) {
+                isPlayer = isSuicide = false;
             } else {
-                return getDisplayName() + deathMsgColor + " was detonated remotely.";
-            }
-        }
-        if (entityKilledBy instanceof ProjectileFireball) {
-            return getDisplayName() + deathMsgColor + " didn't return the serve.";
-        }
-        if (entityKilledBy instanceof MobGiant) {
-            return getDisplayName() + deathMsgColor + " was killed by- wait, what?!";
-        }
-        if (entityKilledBy instanceof EntityLightning) {
-            return getDisplayName() + deathMsgColor + " was grounded.";
-        }
-        if (entityKilledBy instanceof EntityPrimedTNT) {
-            return getDisplayName() + deathMsgColor + " was killed by Popbob.";
-        }
-        if (entityKilledBy instanceof Player) {
-            return getDisplayName() + deathMsgColor + " was backstabbed by " + ((Player) entityKilledBy).getDisplayName() + deathMsgColor + ".";
-        }
-        if (entityKilledBy instanceof MobPig) {
-            return getDisplayName() + deathMsgColor + " is *really* bad at Minecraft.";
-        } else {
-            if (this.world.getBlockMaterial(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z)) == Materials.LAVA) {
-                return getDisplayName() + deathMsgColor + " got lost in the sauce.";
-            }
-            if (this.world.getBlockId(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z)) == Blocks.SPIKES.id()) {
-                return getDisplayName() + deathMsgColor + " fell for the trap.";
-            }
-            if (this.fallDistance > 0) {
-                return getDisplayName() + deathMsgColor + " forgot to tie their laces.";
+                isPlayer = true;
+                isSuicide = player.uuid == this.uuid;
             }
-            if (this.airSupply <= 0) {
-                return getDisplayName() + deathMsgColor + " is sleeping with the fishes.";
+
+            if (projectile instanceof ProjectileArrow) {
+                if (archer instanceof MobSkeleton) return "messages.death.player.killed_by.skeleton";
+                final var isGolden = projectile instanceof ProjectileArrowGolden;
+                if (isSuicide) return (isGolden)
+                    ? "messages.death.player.killed_by.arrow_golden_suicide"
+                    : "messages.death.player.killed_by.arrow_suicide";
+                if (isPlayer) return (isGolden)
+                    ? "messages.death.player.killed_by.arrow_golden_player"
+                    : "messages.death.player.killed_by.arrow_player";
+                return (isGolden)
+                    ? "messages.death.player.killed_by.arrow_golden"
+                    : "messages.death.player.killed_by.arrow";
             }
-            if (this.remainingFireTicks > 0) {
-                return getDisplayName() + deathMsgColor + " was cooked well done.";
+
+            if (projectile instanceof ProjectileCannonball) {
+                if (isSuicide) return "messages.death.player.killed_by.cannonball_suicide";
+                if (isPlayer) return "messages.death.player.killed_by.cannonball_player";
+                return "messages.death.player.killed_by.cannonball";
             }
-            return getDisplayName() + deathMsgColor + " died mysteriously.";
         }
+
+        return "messages.death.player.generic";
     }
 
+
     @Override
     protected void dropDeathItems() {
     }
@@ -1326,22 +1291,22 @@ public abstract class Player
             }
             if (this.bedTilePos == null || !this.bedTilePos.equals(new TilePos(x, y, z))) {
                 if (this.playerSpawnPoint == null || !this.playerSpawnPoint.equals(new TilePos(x, y, z))) {
-                    sendTranslatedChatMessage("bed.setSpawn");
+                    sendMessageTranslated("messages.bed.setSpawn");
                     setPlayerSpawnPoint(new TilePos(x, y, z));
                 }
             }
             if (!this.world.getGameRuleValue(GameRules.ALLOW_SLEEPING)) {
-                sendStatusMessage(I18n.getInstance().translateKey("bed.noAllowSleeping"));
+                sendStatusMessageTranslated("messages.bed.noAllowSleeping");
                 return EnumSleepStatus.DISABLED_BY_GAMERULE;
             }
 
             if (this.world.isDaytime() && this.world.getCurrentWeather() != Weathers.OVERWORLD_STORM) {
-                sendStatusMessage(I18n.getInstance().translateKey("bed.noSleep"));
+                sendStatusMessageTranslated("messages.bed.noSleep");
                 return EnumSleepStatus.NOT_POSSIBLE_NOW;
             }
 
             if (SpawnerMobs.isUnsafeToSleep(this.world, this)) {
-                sendStatusMessage(I18n.getInstance().translateKey("bed.unsafeToSleep"));
+                sendStatusMessageTranslated("messages.bed.unsafeToSleep");
                 return EnumSleepStatus.NOT_SAFE;
             }
         }
@@ -1487,19 +1452,36 @@ public abstract class Player
     /**
      * Translate the string and send it to this player
      */
+    @Deprecated
     public void sendTranslatedChatMessage(String message) {
         sendMessage(I18n.getInstance().translateKey(message));
     }
 
+    public abstract void sendMessage(boolean isStatus, @Nullable TextFormatting.Base format, @NotNull String message);
+    public abstract void sendMessageTranslated(boolean isStatus, @Nullable TextFormatting.Base format, @NotNull String key, @NotNull String... args);
+
+    public void sendMessage(@Nullable TextFormatting.Base format, @NotNull String message) { this.sendMessage(false, format, message); }
+    public void sendStatusMessage(@Nullable TextFormatting.Base format, String message) { this.sendMessage(true, format, message); }
     /**
      * Send a string to this player, displayed in chat
      */
-    public abstract void sendMessage(String message);
-
+    public void sendMessage(@NotNull String message) { this.sendMessage(null, message); }
     /**
      * Send a string to this player, displayed above the hotbar
      */
-    public abstract void sendStatusMessage(String message);
+    public void sendStatusMessage(@NotNull String message) { this.sendStatusMessage(null, message); }
+
+    public void sendMessageTranslated(@Nullable TextFormatting.Base format, @NotNull String key, @NotNull String... args) { this.sendMessageTranslated(false, format, key, args); }
+    public void sendStatusMessageTranslated(@Nullable TextFormatting.Base format, @NotNull String key, @NotNull String... args) { this.sendMessageTranslated(true, format, key, args); }
+    /**
+     * Send text to this player, translated client-side and displayed in chat
+     */
+    public void sendMessageTranslated(@NotNull String key, @NotNull String... args) { this.sendMessageTranslated(null, key, args); }
+    /**
+     * Send text to this player, translated client-side and displayed above the hotbar
+     */
+    public void sendStatusMessageTranslated(@NotNull String key, @NotNull String... args) { this.sendStatusMessageTranslated(null, key, args); }
+
 
     @Override
     public ItemStack getHeldItem() {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
index 4f8df4f8c..04610b5b2 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -25,9 +25,9 @@ public class ItemBed extends Item {
         if (!world.canPlaceInsideBlock(pos1)) {
             pos1 = new TilePos(pos1).add(side.direction());
         }
-        Direction dir = player == null ? Direction.NORTH : player.getHorizontalPlacementDirection(null).opposite();
+        final Direction dir = player == null ? Direction.NORTH : player.getHorizontalPlacementDirection(null).opposite();
         final TilePos pos2 = new TilePos(pos1).sub(dir);
-        
+
         if (!world.canPlaceInsideBlock(pos1) || !world.canPlaceInsideBlock(pos2)) return false;
         
         final var bed = Blocks.BED.getLogic();
@@ -39,9 +39,9 @@ public class ItemBed extends Item {
         
         
         final boolean isPlaced1 = 
-        world.setBlockTypeData(pos1, Blocks.BED, dir.legacyHorizontalIndex());
+            world.setBlockTypeData(pos1, Blocks.BED, dir.legacyIndex());
         final boolean isPlaced2 = isPlaced1 &&
-        world.setBlockTypeData(pos2, Blocks.BED, dir.legacyHorizontalIndex() | BlockLogicBed.IS_HEAD.set(0, 1));
+            world.setBlockTypeData(pos2, Blocks.BED, dir.legacyIndex() | BlockLogicBed.IS_HEAD.set(0, 1));
         if (!isPlaced2) {
             if (isPlaced1) world.setBlockType(pos1, Blocks.AIR);
             return false;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index 453204786..c12f48bc1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -39,7 +39,7 @@ public class ItemDoor extends Item {
         if (!world.canBlockIdBePlacedAt(this.doorBlockBottom.id(), blockPos, false, side)) return false;
 
         Direction leftDir = player.getHorizontalPlacementDirection(side).rotateY(1);
-        int meta = leftDir.legacyHorizontalIndex();
+        int meta = leftDir.legacyIndex();
 
         final var upperPos = blockPos.up(new TilePos());
 
@@ -99,7 +99,7 @@ public class ItemDoor extends Item {
 
         if (!direction.isHorizontal()) direction = Direction.NORTH;
         Direction lefDir = direction.rotateY(1);
-        int meta = lefDir.legacyHorizontalIndex();
+        int meta = lefDir.legacyIndex();
 
         int isSolidBlockLeft = (isSupported(world, blockPos, lefDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir, false) ? 1 : 0);
         int isSolidBlockRight = (isSupported(world, blockPos, lefDir.opposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir.opposite(), true) ? 1 : 0);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
index 6dfaea5f8..748786a61 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
@@ -37,13 +37,13 @@ public class ItemFlag extends Item {
             if (world.getTileEntity(blockPos) instanceof TileEntityFlag flag) {
                 CompoundTag flagData = selfStack.getData().getCompoundOrDefault("FlagData", new CompoundTag());
                 if (hasFlagBeenDrawnOn(selfStack) && doesFlagContainDyes(selfStack)) {
-                    player.sendStatusMessage(I18n.getInstance().translateKey("flag.overwrite"));
+                    player.sendStatusMessageTranslated("messages.flag.overwrite");
                     return false;
                 }
                 flag.copyFlagNBT(flagData);
                 UUIDHelper.writeToTag(flagData, player.uuid, "OwnerUUID"); // Sets the owner of the copied flag to the current player so they can actually modify the flag once they place it
                 selfStack.getData().putCompound("FlagData", flagData);
-                player.sendStatusMessage(I18n.getInstance().translateKey("flag.copied"));
+                player.sendStatusMessageTranslated("messages.flag.copied");
                 return true;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
index e8c77a889..780d05ef7 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -132,7 +132,7 @@ public class ItemMap extends Item implements IComplexItem
 					ItemMapSavedData mapData = getOrCreateSavedData((short) selfStack.getMetadata(), scale, world);
 					TileEntityFlag flag = (TileEntityFlag) world.getTileEntity(blockPos);
 					if (mapData.createNewWaypoint(flag) == ItemMapSavedData.FlagError.FULL) {
-						if (player != null) player.sendTranslatedChatMessage("flag.full");
+						if (player != null) player.sendMessageTranslated("messages.flag.full");
 						break;
 					}
 				}
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index 15b0765d7..b37151054 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -23,7 +23,7 @@ public class ItemWandSpawner extends Item implements IDispensable
     @Override
     public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
         if (player.gamemode != Gamemodes.CREATIVE){
-            player.sendTranslatedChatMessage("wand.wrongmode");
+            player.sendMessageTranslated("messages.wand.wrongmode");
             return selfStack;
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/lang/Language.java b/game/core/src/main/java/net/minecraft/core/lang/Language.java
index 1599c501f..c3083c8fe 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/Language.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/Language.java
@@ -2,6 +2,8 @@ package net.minecraft.core.lang;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.data.registry.Registries;
+
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.io.BufferedReader;
@@ -308,5 +310,9 @@ public class Language {
         public boolean isDefault() {
             return true;
         }
+
+        public @NotNull Properties getEntries() {
+            return this.entries;
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java b/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java
index b94457bea..008847bfb 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/TextFormatting.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.net.command;
 
 import org.jetbrains.annotations.Nullable;
+import org.jetbrains.annotations.NotNull;
 
 public class TextFormatting {
 	public static final String FORMAT_CHARS = "0123456789abcdefklmnopr+-";
@@ -114,4 +115,168 @@ public class TextFormatting {
 	public static TextFormatting get(int id) {
 		return FORMATTINGS[id];
 	}
+
+	public synchronized static @NotNull String scoped(@NotNull String str) {
+		interface ctx { static StringBuilder sb = new StringBuilder(); }
+		ctx.sb.setLength(0);
+		ctx.sb.ensureCapacity(str.length() + 4);
+		ctx.sb.append(PUSH);
+		ctx.sb.append(str);
+		ctx.sb.append(POP);
+		return ctx.sb.toString();
+	} 
+
+	public static record Base(
+		@NotNull Color color,
+		boolean obfuscated,
+		boolean bold,
+		boolean strikethrough,
+		boolean underline,
+		boolean italic,
+		boolean outline
+	) {
+		public static final @NotNull Base WHITE = new Base(Color.WHITE);
+		public static final @NotNull Base ORANGE = new Base(Color.ORANGE);
+		public static final @NotNull Base MAGENTA = new Base(Color.MAGENTA);
+		public static final @NotNull Base LIGHT_BLUE = new Base(Color.LIGHT_BLUE);
+		public static final @NotNull Base YELLOW = new Base(Color.YELLOW);
+		public static final @NotNull Base LIME = new Base(Color.LIME);
+		public static final @NotNull Base PINK = new Base(Color.PINK);
+		public static final @NotNull Base GRAY = new Base(Color.GRAY);
+		public static final @NotNull Base LIGHT_GRAY = new Base(Color.LIGHT_GRAY);
+		public static final @NotNull Base CYAN = new Base(Color.CYAN);
+		public static final @NotNull Base PURPLE = new Base(Color.PURPLE);
+		public static final @NotNull Base BLUE = new Base(Color.BLUE);
+		public static final @NotNull Base BROWN = new Base(Color.BROWN);
+		public static final @NotNull Base GREEN = new Base(Color.GREEN);
+		public static final @NotNull Base RED = new Base(Color.RED);
+		public static final @NotNull Base BLACK = new Base(Color.BLACK);
+
+		public Base(@NotNull Color color) {
+			this(color, false, false, false, false, false, false);
+		}
+
+		public @NotNull Base withStyle(
+			boolean obfuscated,
+			boolean bold,
+			boolean strikethrough,
+			boolean underline,
+			boolean italic,
+			boolean outline
+		) {
+			return new Base(this.color, obfuscated, bold, strikethrough, underline, italic, outline);
+		}
+
+		public short pack() {
+			short res = 0;
+			res |= (this.obfuscated)    ? 0b0000_0001 : 0;
+			res |= (this.bold)          ? 0b0000_0010 : 0;
+			res |= (this.strikethrough) ? 0b0000_0100 : 0;
+			res |= (this.underline)     ? 0b0000_1000 : 0;
+			res |= (this.italic)        ? 0b0001_0000 : 0;
+			res |= (this.outline)       ? 0b0010_0000 : 0;
+			res |= (this.color.ch) << 8;
+			return res;
+		}
+
+		public static @NotNull Base unpack(short packed) {
+			return new Base(
+				Color.fromByte((byte)(packed >> 8)),
+				(packed & 0b0000_0001) != 0,
+				(packed & 0b0000_0010) != 0,
+				(packed & 0b0000_0100) != 0,
+				(packed & 0b0000_1000) != 0,
+				(packed & 0b0001_0000) != 0,
+				(packed & 0b0010_0000) != 0
+			);
+		}
+
+		@Override
+		public final synchronized String toString() {
+			interface ctx { static StringBuilder sb = new StringBuilder(14); }
+			ctx.sb.setLength(0);
+
+			if (this.obfuscated)    ctx.sb.append(OBFUSCATED);
+			if (this.bold)          ctx.sb.append(BOLD);
+			if (this.strikethrough) ctx.sb.append(STRIKETHROUGH);
+			if (this.underline)     ctx.sb.append(UNDERLINE);
+			if (this.italic)        ctx.sb.append(ITALIC);
+			if (this.outline)       ctx.sb.append(OUTLINE);
+			if (this.color != Color.NONE) ctx.sb.append(this.color.str);
+
+			return ctx.sb.toString();
+		}
+
+		public static enum Color {
+			NONE ((byte)0),
+			WHITE (Const.WHITE),
+			ORANGE (Const.ORANGE),
+			MAGENTA (Const.MAGENTA),
+			LIGHT_BLUE (Const.LIGHT_BLUE),
+			YELLOW (Const.YELLOW),
+			LIME (Const.LIME),
+			PINK (Const.PINK),
+			GRAY (Const.GRAY),
+			LIGHT_GRAY (Const.LIGHT_GRAY),
+			CYAN (Const.CYAN),
+			PURPLE (Const.PURPLE),
+			BLUE (Const.BLUE),
+			BROWN (Const.BROWN),
+			GREEN (Const.GREEN),
+			RED (Const.RED),
+			BLACK (Const.BLACK);
+
+			private static final class Const {
+				static final byte WHITE = '0';
+				static final byte ORANGE = '1';
+				static final byte MAGENTA = '2';
+				static final byte LIGHT_BLUE = '3';
+				static final byte YELLOW = '4';
+				static final byte LIME = '5';
+				static final byte PINK = '6';
+				static final byte GRAY = '7';
+				static final byte LIGHT_GRAY = '8';
+				static final byte CYAN = '9';
+				static final byte PURPLE = 'a';
+				static final byte BLUE = 'b';
+				static final byte BROWN = 'c';
+				static final byte GREEN = 'd';
+				static final byte RED = 'e';
+				static final byte BLACK = 'f';
+			}
+	
+			public final byte ch;
+			public final String str;
+
+			Color(byte ch) {
+				assert (ch & ~0x7F) == 0;
+				this.ch = ch;
+				this.str = (ch == 0)
+					? ""
+					: "" + SPECIAL_CHAR + (char)ch;
+			}
+
+			public static @NotNull Color fromByte(byte value) {
+				return switch (value) {
+					default -> NONE;
+					case Const.WHITE -> WHITE;
+					case Const.ORANGE -> ORANGE;
+					case Const.MAGENTA -> MAGENTA;
+					case Const.LIGHT_BLUE -> LIGHT_BLUE;
+					case Const.YELLOW -> YELLOW;
+					case Const.LIME -> LIME;
+					case Const.PINK -> PINK;
+					case Const.GRAY -> GRAY;
+					case Const.LIGHT_GRAY -> LIGHT_GRAY;
+					case Const.CYAN -> CYAN;
+					case Const.PURPLE -> PURPLE;
+					case Const.BLUE -> BLUE;
+					case Const.BROWN -> BROWN;
+					case Const.GREEN -> GREEN;
+					case Const.RED -> RED;
+					case Const.BLACK -> BLACK;
+				};
+			}
+		}
+	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
index 016ec2376..e4ebde803 100644
--- a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
@@ -91,8 +91,12 @@ public abstract class PacketHandler {
         handleInvalidPacket(packetTakeItemEntity);
     }
 
-    public void handleChat(@NotNull PacketChat packetChat) {
-        handleInvalidPacket(packetChat);
+    public void handleMessage(@NotNull PacketMessage packetMessage) {
+        handleInvalidPacket(packetMessage);
+    }
+    
+    public void handleTranslatableMessage(@NotNull PacketMessageTranslatable packetMessageTranslatable) {
+        handleInvalidPacket(packetMessageTranslatable);
     }
 
     public void handleAddEntity(@NotNull PacketAddEntity packetAddEntity) {
@@ -231,10 +235,6 @@ public abstract class PacketHandler {
         handleInvalidPacket(packetSleep);
     }
 
-    public void handleBedMessage(@NotNull PacketBedMessage packetBedMessage) {
-        handleInvalidPacket(packetBedMessage);
-    }
-
     public void handleWeatherEffect(@NotNull PacketWeatherEffect packetWeatherEffect) {
         handleInvalidPacket(packetWeatherEffect);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
index c99415d3f..8e3aaf97f 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -256,7 +256,7 @@ public abstract class Packet
         addMapping(0, true, true, PacketKeepAlive.class);
         addMapping(1, true, true, PacketLogin.class);
         addMapping(2, true, true, PacketHandshake.class);
-        addMapping(3, true, true, PacketChat.class);
+        addMapping(3, true, true, PacketMessage.class);
         addMapping(4, true, false, PacketSetTime.class);
         addMapping(5, true, false, PacketSetEquippedItem.class);
         addMapping(6, true, false, PacketSetSpawnPosition.class);
@@ -305,7 +305,7 @@ public abstract class Packet
         addMapping(61, true, false, PacketPlaySound.class);
         addMapping(62, true, false, PacketPlaySoundDirect.class);
         addMapping(63, true, false, PacketAddParticle.class);
-        addMapping(70, true, false, PacketBedMessage.class);
+        addMapping(70, true, false, PacketMessageTranslatable.class);
         addMapping(71, true, false, PacketWeatherEffect.class);
         addMapping(72, true, false, PacketUpdatePlayerProfile.class);
         addMapping(73, true, false, PacketWeatherStatus.class);
